/**
 * ab_yandex_maps package for Concrete5
 * Copyright Copyright 2017-2019, Alex Borisov
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * @author Alex Borisov <linuxoidoz@gmail.com>
 * @package Concrete\Package\ab_yandex_maps
 */

$(document).ready(function(e) {
    if(CCM_EDIT_MODE){
        return;
    }
    
    ymaps.ready(function () {
        $.each($('.ab-yandex-map[data-jq]'), function(index, element) {
            var jq_data = $.parseJSON($(element).attr('data-jq'));
            
            var myYandexBalloon = '<div class="my-balloon">';
            if (jq_data.show_picture) {
                myYandexBalloon += '<div class="left">';
                myYandexBalloon += '<img src="' + jq_data.picture + '" />';
                myYandexBalloon += '</div>';
            }
            myYandexBalloon += '<div class="right">'; 
            myYandexBalloon += '<h3>' + jq_data.name + '</h3>';
            myYandexBalloon += jq_data.show_address ? ('<strong>' + jq_data.t_address + '</strong> ' + jq_data.address + '<br />') : '';
            myYandexBalloon += jq_data.show_tel ? ('<strong>' + jq_data.t_tel + '</strong> ' + jq_data.tel + '<br />') : '';
            myYandexBalloon += jq_data.show_email ? ('<strong>' + jq_data.t_email + '</strong> <a href="mailto:' + jq_data.email + '">' + jq_data.email + '</a>') : '';
            myYandexBalloon += '</div>';
            myYandexBalloon += '</div>';
                
            var myYandexHint = '<div class="my-hint">';
            myYandexHint += '<b>' + jq_data.name + '</b><br />';
            myYandexHint += jq_data.address + '<br />';
            myYandexHint += jq_data.tel + '<br />';
            myYandexHint += jq_data.email;
            myYandexHint += '</div>';
            
            var myYandexMap = new ymaps.Map(element, {
                    center: [jq_data.latitude, jq_data.longitude],
                    zoom: jq_data.zoom ? jq_data.zoom : 12,
                    behaviors: ['default']
                }
            );
            jq_data.lock_wheel ? myYandexMap.behaviors.enable('scrollZoom') : myYandexMap.behaviors.disable('scrollZoom');

            var myYandexBalloonLayout = ymaps.templateLayoutFactory.createClass(myYandexBalloon);

            var myYandexHintLayout = ymaps.templateLayoutFactory.createClass(myYandexHint);
            
            var myYandexPlacemark = new ymaps.Placemark(
                [jq_data.latitude, jq_data.longitude], {
                    iconCaption: jq_data.name
                }, {
                    balloonPanelMaxMapArea: 0,
                    preset: "islands#redHomeIcon",
                    balloonContentLayout: myYandexBalloonLayout,
                    hintLayout: myYandexHintLayout,
                }
            );
            myYandexMap.geoObjects.add(myYandexPlacemark);
        });
    });
});
